####################################
#
# Solution for stage J
#
class Player:
        def __init__(self,board_size=0,subs_level=0):
            self.sock = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
            self.board_size = board_size
            self.subs_level = subs_level
        def ConnnectPlayer(self,ip,port):
            try:
                self.sock.connect((ip,port))
                buf = self.sock.recv(20)
            except socket.error, (errno, strerror):
                print "Network problems:",strerror
                return 0
            size_s, subs_level_s = buf.split(' ')
            self.board_size = int(size_s)
            self.subs_level = int(subs_level_s)
            # FF read num of subs and sizes using ConfigParser
            self.my_board = Board(self.board_size,self.board_size)
            self.other_board = Board(self.board_size,self.board_size)
            return 1
        def RecvSubs(self):
            buf = self.sock.recv(RECV_SIZE)
            for sub_str in buf.split(' '):
                cells = []
                for cell_str in sub_str.split(','):
                    x,y = cell_str.split(':')
                    cells.append(self.other_board.cells[int(y)][int(x)])
                # we assume that errors are detected at opponent's side
                self.other_board.AddSub(cells)
        def SendSubs(self):
            buf = " ".join(map(lambda x:x.SockString(), self.my_board.subs))
            self.sock.send(buf)
        def AcceptPlayer(self,port):
            try:
                self.sock.bind(('', port))
                self.sock.listen(1)
                self.sock, addr = self.sock.accept()
                buf = str(self.board_size) + " " + str(self.subs_level)
                self.sock.send(buf)
            except socket.error, (errno, strerror):
                print "Network problems:",strerror
                return 0
            self.my_board = Board(self.board_size,self.board_size)
            self.other_board = Board(self.board_size,self.board_size)
            # FF send num of subs
            return 1
        def CheckCoordinates(self,string):
            s_x,s_y = string.split(' ')
            x,y = int(s_x), int(s_y)
            if x >= self.board_size or x < 0 or y >= self.board_size or y < 0:
                raise ValueError, "Coordinates should be between 0 and " + str(self.board_size)
            return x,y
        def GetSubsFromPlayer(self):
            print "Please enter the locations of your subs:"
            for sub_size in range(self.subs_level,0,-1):
                for i in range(self.subs_level-sub_size+1):
                    rc=0
                    while (rc is 0):
                        print "Please enter sub of size",sub_size
                        sub = []
                        for c in range(sub_size):
                            x,y = my_input("Please enter coordinates of cell "+str(c)+": " \
                                           ,self.CheckCoordinates)
                            sub.append(self.my_board.cells[y][x])
                        rc, err = self.my_board.AddSub(sub)
                        if (rc is 0):
                            print "Bad input given:", err
                        else:
                            print "Your Board:"
                            print self.my_board.ToString()
        def GetMoveFromPlayer(self):
            x,y = my_input("Please enter your guess: ",self.CheckCoordinates)
            self.SendMove(x,y)
            hit = self.other_board.Hit(x,y)
            if hit == 1:
                print "You hit!"
            elif hit == 2:
                print "You hit and sunk a submarine!"
            else:
                print "You missed..."
            self.PrintBoards()
            return hit
        def GetMoveFromOtherPlayer(self):
            print "Waiting for opponent to move..."
            x,y = self.RecvMove()
            hit = self.my_board.Hit(int(x),int(y))
            if hit == 1:
                print "You were hit!"
            elif hit == 2:
                print "You were hit and lost a submarine!"
            else:
                print "Opponent missed..."
            self.PrintBoards()
            return hit
        def SendMove(self,x,y):
            self.sock.send(str(x)+":"+str(y))
        def RecvMove(self):
            buf = self.sock.recv(10)
            return buf.split(':')
        def PrintBoards(self):
            print "Your Board:"
            print self.my_board.ToString()
            print "Other's Board:" 
            print self.other_board.ToString(0)
        def PlayGame(self,other_player_start=0):
            # Till end of game
            while (1):
                if (other_player_start):
                    # Get move from other player
                    while ( self.GetMoveFromOtherPlayer() ):
                        if (self.my_board.is_done):
                            print "You lost!"
                            return
                        else:
                            print "Opponent has another turn"
                # Get move from player
                while ( self.GetMoveFromPlayer() ):
                    if (self.other_board.is_done):
                        print "You won!"
                        return
                    else:
                        print "You have another turn"
                other_player_start=1
        def RunServer(self,port):
            # wait for connection from a player
            print "Waiting for opponent..."
            if (not self.AcceptPlayer(port)):
                return
            # Get Subs from player
            print "Opponent connected..."
            self.GetSubsFromPlayer()
            # send subs to other player
            self.SendSubs()
            # read subs from other player
            print "Waiting for opponent to select subs..."
            self.RecvSubs()
            print "... Done."
            # play the game!
            self.PlayGame()
        def RunClient(self,ip,port):
            # connect to server
            print "Connecting to play..."
            if (not self.ConnnectPlayer(ip, port)):
                return
            print "... Done."
            # Get Subs from player
            self.GetSubsFromPlayer()
            # read subs from other player
            print "Waiting for player to select subs..."
            self.RecvSubs()
            print "... Done."
            # send subs to other player
            self.SendSubs()
            # play the game! (other player starts)
            self.PlayGame(1)
#
####################################
